// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXL = 100'000;
int MAXL_NUM = 9;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    if (validator.group() == "2") {
        MAXL = 300;
        MAXL_NUM = 2;
    } else if (validator.group() == "4") {
        MAXL = 1000;
    }

    string s = inf.readLine();
    ensuref(2 <= szof(s) && szof(s) <= MAXL, "length of line should be in [2, %d]", MAXL);

    for (char c : s) {
        ensuref(c == '-' || c == '+' || ('0' <= c && c <= '9'), "incorrect symbol '%c'", c);
    }

    if (validator.group() == "1") {
        for (char c : s) {
            ensuref(c != '+' && c != '-', "in group #1, symbols can't be '+' or '-'");
        }
    }

    if (validator.group() == "3") {
        for (char c : s) {
            ensuref(c != '-', "in group #3, symbols can't be '-'");
        }
    }

    string cur_num = "";
    for (char c : s) {
        if ('0' <= c && c <= '9') {
            cur_num += c;
        } else {
            ensuref(2 <= szof(cur_num) && szof(cur_num) <= MAXL_NUM, "all numbers should have length in [2, %d]", MAXL_NUM);
            ensuref(cur_num.front() != '0', "number can't have leading zeroes");
            cur_num = "";
        }
    }

    ensuref(2 <= szof(cur_num) && szof(cur_num) <= MAXL_NUM, "all numbers should have length in [2, %d]", MAXL_NUM);
    ensuref(cur_num.front() != '0', "number can't have leading zeroes");

    inf.readEof();

    return 0;
}