// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const ll MOD = 1000000000000000009;

void add(ll& a, ll b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

ll sum(ll a, ll b) {
	add(a, b);
	return a;
}

ll mult(ll a, ll b) { // works for MOD 8e18
    ll k = (ll)((long double)a * b / MOD);
    ll r = a * b - MOD * k;
    if (r < 0) r += MOD;
    if (r >= MOD) r -= MOD;
    return r;
}

ll mpow(ll a, ll b) {
	ll ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n);
	unordered_set<ll> have_pows;
	vector<ll> vals;
	for (int& num : arr) {
		cin >> num;
		ll val = mpow(2, num);
		vals.push_back(val);
		for (int i = 0; 1 << i <= n; ++i) {
			have_pows.insert(val);
			val = sum(val, val);
		}
	}

	vector<ll> pref = {0};
	for (ll num : vals) {
		pref.push_back(sum(pref.back(), num));
	}

	auto get_sum = [&](int l, int r) {
		return sum(pref[r], MOD - pref[l]);
	};

	int ans = 0;

	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			if (have_pows.count(get_sum(i, j + 1))) {
				++ans;
			}
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}