// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

void solve() {
	int n;
	cin >> n;
	vector<int> arr(n);
	vector<int> vals;
	for (int& num : arr) {
		cin >> num;
		vals.push_back(mpow(2, num));
	}

	ll ans = 0;

	unordered_map<int, int> cnt_sums;

	function<void(int, int)> rec = [&](int l, int r) {
		if (l + 1 == r) {
			++ans;
			return;
		}


		int mid = (l + r) / 2;
		int sumr = 0;
		int posl = mid - 1;
		int max_pow = 0;
		int max_pow_val = 1;
		int suml = 0;
		cnt_sums.clear();
		for (int i = mid; i < r; ++i) {
			add(sumr, vals[i]);
			if (max_pow < arr[i]) {
				max_pow = arr[i];
				max_pow_val = vals[i];
			}
			while (posl >= l && arr[posl] <= max_pow) {
				add(suml, vals[posl]);
				cnt_sums[suml]++;
				--posl;
			}
			int tmp = max_pow_val;
			for (int j = 0; 1 << j <= i - posl; ++j) {
				int left = sum(tmp, MOD - sumr);
				if (cnt_sums.count(left)) {
					ans += cnt_sums[left];
				}
				tmp = sum(tmp, tmp);
			}
		}

		sumr = 0;
		int posr = mid;
		max_pow = 0;
		max_pow_val = 1;
		suml = 0;
		cnt_sums.clear();
		for (int i = mid - 1; i >= l; --i) {
			add(suml, vals[i]);
			if (max_pow < arr[i]) {
				max_pow = arr[i];
				max_pow_val = vals[i];
			}
			while (posr < r && arr[posr] < max_pow) {
				add(sumr, vals[posr]);
				cnt_sums[sumr]++;
				++posr;
			}
			int tmp = max_pow_val;
			for (int j = 0; 1 << j <= posr - i; ++j) {
				int left = sum(tmp, MOD - suml);
				if (cnt_sums.count(left)) {
					ans += cnt_sums[left];
				}
				tmp = sum(tmp, tmp);
			}
		}

		rec(l, mid);
		rec(mid, r);
	};

	rec(0, n);

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}