#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const ll M = 1228228228231ll;

void add(ll &a, ll b) {
  a += b;
  if (a >= M) a -= M;
}

long long mul( long long a, long long b) {
  long long m = M;
  long long q = (long long)((long double)a * (long double)b / (long double)m);
  long long r = a * b - q * m;
  return (r + 5 * m) % m;
}

ll pw(ll a, ll n) {
  ll res = 1;
  while (n) {
    if (n % 2 == 0) {
      a = mul(a, a);
      n /= 2;
    } else {
      res = mul(res, a);
      n--;
    }
  }
  return res;
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  vector <int> a(n);
  vector <ll> value(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    value[i] = pw(2, a[i]);
  }
  int lg = 0;
  while ((1 << lg) <= n) lg++;
  ll ans = 0;
  for (int i = 0; i < n; i++) {
    ll s = 0;
    int mx = 0;
    ll h;
    for (int j = i; j < n; j++) {
      add(s, value[j]);
      if (a[j] > mx) {
        mx = a[j];
        h = value[j];
      }
      ll me = h;
      for (int z = mx; z <= mx + lg; z++) {
        if (me == s) {
          ans++;
        }
        add(me, me);
      }
    }
  }
  cout << ans << '\n';
}

