#include "testlib.h"
#include <string>
#include <map>
using namespace std;

const int MAXN = int(1e5);
const int MAXD[4] = {3, 3, 1, 3};
const int MAXM[4] = {20, 1, int(1e5), int(1e5)};
map<string, int> SI = {
    {"tera", 12},  
    {"giga" , 9},   
    {"mega" , 6},  
    {"kilo" , 3},  
    {"deci" , -1}, 
    {"centi", -2}, 
    {"milli", -3}, 
    {"micro", -6}, 
    {"nano" , -9} 
};
const string END1 = "meter";
const string END2 = "meter^";


int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int group = 0;
    group = atoi(validator.group().c_str());
    string s = inf.readString();
    size_t n = s.size();
    ensuref(n <= MAXN, "|s| > %d", MAXN);
    inf.readEof();
    ensuref((n >= END1.size() && s.substr(n - END1.size(), END1.size()) == END1) 
         || (n >= END2.size() + 1 && s.substr(n - END2.size() - 1, END2.size()) == END2), 
            "Incorrect end of string");
    int p;
    if (s[s.size() - 2] == '^')
    {
        p = s[s.size() - 1] - '0';
        n -= END2.size() + 1;
    }
    else
    {
        p = 1;
        n -= END1.size();
    }
    ensuref(1 <= p && p <= MAXD[group], "Incorrect power of meters");
    //cout << p << ' '  << n << endl;
    size_t i = 0;
    int cnt = 0;
    while (i < n)
    {
        ensuref(i + 4 <= n, "Unexpected end of prefix");
        string start = s.substr(i, 4);
        if (SI[start]) 
            i = i + 4;
        else
        {
            ensuref(i + 5 <= n, "Unexpected end of prefix");
            start = s.substr(i, 5);
            ensuref(SI[start], "Unexpected substring from %d to %d", i + 1, i + 5);
            i = i + 5; 
        }
        cnt++;
    }
    ensuref(cnt <= MAXM[group], "Incorrect number of prefixes");
    return 0;
}